// Top-level build file where you can add configuration options common to all sub-projects/modules.
//apply plugin: 'com.android.application'
//apply plugin: 'kotlin-android'
//apply from: 'dependencies.gradle'

import com.android.build.gradle.BaseExtension

plugins {
    id("com.android.application") version "7.4.1" apply false
    id("com.android.library") version "7.4.1" apply false
    id("org.jetbrains.kotlin.android") version "1.8.10" apply false
}

buildscript {
    extra.apply {
        set("kotlin_version", "1.8.10")
        set("androidx_navigation_version", "2.5.3")
        set("dagger_hilt_android_version", "2.45")
        // This is required as of Android Studio 4.1, this is required for modules/libraries since VERSION_CODE and VERSION_NAME is no longer included in the generated build config
        // See: https://issuetracker.google.com/issues/158695880
        // Use this field to set the major/minor/patch numbers for the whole app.
        set("versionName", "1.0.0")
        // Use this field to set the VersionCode for the whole app, this should not updated manually, but via `fastlane BumpReleaseVersion`
        set("versionCode", 905)
    }

    dependencies {
        val nav_version = "2.5.3"
        classpath("androidx.navigation:navigation-safe-args-gradle-plugin:$nav_version")
        classpath("com.google.dagger:hilt-android-gradle-plugin:2.45")
        // A plugin to enable JUnit5 in Android projects (Still requires basic JUnit5 dependencies etc)
        classpath("de.mannodermaus.gradle.plugins:android-junit5:1.8.2.1")
        classpath("androidx.navigation:navigation-safe-args-gradle-plugin:2.5.3")
    }
}

//fun CommonExtension<*, *, *, *>.testOptions(block: org.jetbrains.kotlin.gradle.dsl.KotlinJvmOptions.() -> Unit) {
//    (this as ExtensionAware).extensions.configure("testOptions", block)
//    (this as ExtensionAware).extensions.configure("kotlinOptions", block)
//}
val Project.android: BaseExtension
    get() = extensions.findByName("android") as? BaseExtension
        ?: error("Not an Android module: $name")


//subprojects {
//    // Add jacoco to all modules, except test assertions module
//    if (project.name != "TestAssertions") {
//        println("Add jacoco.gradle to $project.name")
//        apply("${project.rootDir}/jacoco.gradle")
//
//        project.afterEvaluate {
//            dependencies {
//                // Adds Test related modules to other dependencies
//                add("testImplementation", project(":TestAssertions"))
//            }
//
//
////            project.extensions.findByType(CommonExtension::class.java)?.apply {
////                testOptions {
////
////                }
//////                testOptions {
////
//////                }
////                this.apply {
////
////                }
////            }
////            project.extensions.findByType(BaseExtension::class.java)?.apply {
//
//
//
////            android  {
//                // Set output to qa-reports folder in root of project
////            project.extensions.findByType(BaseExtension::class.java)?.apply {
////                testOptions {
////                    reports {
////                        junitXml.isEnabled = true
////                        html.isEnabled = true
////                    }
////                    unitTests.all {
////                        reports {
////                            junitXml.required = true
////                            html.required = true
////                            junitXml.destination = file("$buildDir/test-results/${name}/junit-report.xml")
////                            html.destination = file("$buildDir/reports/tests/${name}")
////                        }
////                        testLogging {
////                            events(TestLogEvent.PASSED, TestLogEvent.SKIPPED, TestLogEvent.FAILED)
////                            exceptionFormat = TestExceptionFormat.FULL
////                        }
//////                        reports.html.destination = file("$buildDir/../../qa-reports/unit-tests-${versionName}-${versionCode}/${project.name}")
////                    }
////                }
//
//            }
//        }
//    }
//}
tasks.create<Delete>("clean") {
    println("Clean extra tasky thing")
    delete(rootProject.buildDir)
    delete("${rootProject.rootDir}/qa-reports")
}
//tasks.register<Delete>("clean") {
//    delete(rootProject.buildDir)
//    delete("${rootProject.rootDir}/qa-reports")
//}
//
//afterEvaluate {
//    val runAllUnitTests by tasks.registering {
//        dependsOn(
//            "app:testProjectEnvDebugUnitTest",
//            "api:testProjectEnvDebugUnitTest",
//            "repo:testProjectEnvDebugUnitTest",
//            "shared:testProjectEnvDebugUnitTest"
//        )
//    }
//
//    val generateReports by tasks.registering {
//        dependsOn(
//            "app:customJacocoTestReport",
//            "api:customJacocoTestReport",
//            "repo:customJacocoTestReport",
//            "shared:customJacocoTestReport"
//        )
//    }
//}
